/* 
 * File:   Canvas.h
 * Author: Michael
 *
 * Created on 21 August 2015, 15:44
 */

#ifndef CANVAS_H
#define	CANVAS_H

#include <sf2d.h>
#include <3ds.h>
#include <stdio.h>
#include <string.h>
#include "List.h"
#include <iostream>
#include <sfil.h>



class Canvas {
public:
    Canvas();
    void draw(List CoordinateList);
    void drawToken(int x, int y);
    bool drawState;
    bool GameOver;
    void setScore(float Score)
    {
        this->Score=Score;
    }
    void setHighscore(float Highscore)
    {
        this->Highscore = Highscore;
    }
    int Tx;
    int Ty;
    void setNewScore()
    {
        newScore=true;
    }
    void kill();
    
private:
    PrintConsole TopScreen, BottomScreen;
    int paintx;
    int painty;
    List CoordinateList;
    float Highscore;
    float Score;
    bool newScore;
    sf2d_texture *tex1;
    sf2d_texture *tex2;
    sf2d_texture *tex3;
    sf2d_texture *tex4;
    sf2d_texture *tex5;
    sf2d_texture *tex6;
    sf2d_texture *tex7;
    sf2d_texture *tex8;
    List NodeList; 
    

};

#endif	/* CANVAS_H */

