/* 
 * File:   List.cpp
 * Author: Michael
 * 
 * Created on 21 August 2015, 17:17
 */

#include "List.h"

using namespace std;

List::List(void)
{
    Head = End = NULL;

}

void List::attach(int x, int y, char dir)
{
    Data con(x,y);
    Node *newnode = new Node(con);
    newnode->dir = dir;
    if(ListEmpty())
    {
        Head = End = newnode;
    }
    else
    {
        End->next = newnode;
        End = newnode;
    }
}

bool List::ListEmpty()
{
    return (Head == NULL)? true : false;
}


bool List::GameOverCheck()
{

    if(Head->getContent().x > 390 || Head->getContent().x < 0 || Head->getContent().y > 230 || Head->getContent().y < 0)
    {
        return true;


    }
    return false;


}

void List::clear()
{
    if(!ListEmpty())
    {
       Head->next=NULL;
       End = Head= NULL;

    }
}


List List::getCoordinates()
{
    List NodeList;
    Node *p = Head;
    while(p!=NULL)
    {
        NodeList.attach(p->getContent().getX(), p->getContent().getY(),p->dir);
        p = p->next;
    }
    return NodeList;
}

bool List::Cannibal()
{
    bool a = false;

    
        int x = Head->getContent().getX();
        int y = Head->getContent().getY();

        Node *p = Head->next;

        while(p!=NULL)
        {
            if(p->getContent().getX()==x && p->getContent().getY() == y)
            {
                a=true;
                break;
            }
            else
            {
               p=p->next;
            }
        }

    
    return a;
}

bool List::contains(int x, int y)
{
    bool a = false;
    Node *p = Head;
    while(p!=NULL)
    {
        if(p->getContent().getX() == x && p->getContent().getY() == y)
        {
            a = true;
            break;
        }
        else
        {
            p = p->next;
        }
       
    }
     return a;
}