/* 
 * File:   Node.cpp
 * Author: Michael
 * 
 * Created on 21 August 2015, 17:22
 */

#include "Node.h"

Node::Node(Data content)
:content(content)
{
    next = NULL;
}

void Node::move(char dir)
{
    int ox = content.x;
    int oy = content.y;
    char dir_old = this->dir;
    this->dir = dir;
    switch(dir)
    {
    case 'u':
        content.y-=10;
        break;

    case 'd':
        content.y+=10;
        break;

    case 'r':
        content.x+=10;
        break;

    case 'l':
        content.x-=10;
        break;
    }

    if(next!=NULL)
    {
        next->move(ox, oy, dir_old);
    }


}

void Node::move(int nx, int ny, char dir)
{
    int ox = content.getX();
    int oy = content.getY();
    content.x = nx;
    content.y = ny;
    char dir_old = this->dir;
    this->dir = dir;
    if(next!=NULL)
    {
        next->move(ox,oy, dir_old);
    }

}

