/* 
 * File:   main.cpp
 * Author: Michael
 *
 * Created on 21 August 2015, 15:30
 */


#include "Game.h"
#include "sf2d.h"
#include <string.h>
#include <malloc.h>
#include <inttypes.h>
#include <stdlib.h>

Game *Snake = (Game*) malloc(sizeof(Game));

Handle threadHandle, threadRequest;

#define STACKSIZE (1024*1024)

volatile bool threadExit = false;

bool run = true;

void move()
{
    if(Snake != NULL)
    {Snake->moveSnake();}
}


void ThreadSnake(void *arg)
{
    while(true)
    {
        svcWaitSynchronization(threadRequest, U64_MAX);
	svcClearEvent(threadRequest);		

        if(threadExit)
        {
            svcExitThread();
        }
        if(Snake == NULL)
        {
           
            Snake = new Game();
            Snake->init();
            
        }

    }

    
      
}




int main(int argc, char** argv) {
    Snake = NULL;
    
    
    svcCreateEvent(&threadRequest,0);    
    u32 *threadStack =(u32*) memalign(32, STACKSIZE);
    
        
        
        Result ret = svcCreateThread(&threadHandle, ThreadSnake, 0, &threadStack[STACKSIZE/4], 0x3f,0);
        
        svcSignalEvent(threadRequest);
        while(aptMainLoop() && run)
        {
           
                svcSleepThread(100000000);
                               
                if(Snake->GameRunning)
                {move();}
                if(Snake->lock){(Snake->lock=false);}
                if(!Snake->status)
                {
                    run = false;
                }

            
                  
        }
        Snake->status=false;
        Snake->widget->kill();
        threadExit = true;
        svcSleepThread(10000000ULL);
        svcCloseHandle(threadHandle);
        free(threadStack);
        sf2d_fini();
        gfxExit();
	return 0;
    
    
  
}


