/* 
 * File:   Game.h
 * Author: Michael
 *
 * Created on 21 August 2015, 15:28
 */

#ifndef GAME_H
#define	GAME_H
#include "Canvas.h"
#include "List.h"
#include <stdio.h>
#include <time.h>
#include <iostream>
#include <3ds.h>
#include <sf2d.h>



class Game {
public:
    Game();
    virtual ~Game();
    PrintConsole TopScreen, BottomScreen;
    u8 buf0[0x300];
    u8 buf1[0x20];
    void init();
    void StartGame();
    void Start();
    void GameOverCheck();
    List snake;
    char dir;
    bool GameRunning;
    bool status;
    void DrawToken();
    void moveSnake();
    void Quit();
    bool lock;
    Canvas *widget = (Canvas*)malloc(sizeof(Canvas));;
private:
    
    bool TokenCheck();
    void eaten();
    float Score;
    float Highscore;
    void setScore();
    bool newScore;
    bool released;
    char last_dir;
    bool pause;
    char next_dir;

};

#endif	/* GAME_H */

